#! /bin/bash
############################################################################
##                                                                        ##
##     Copyright (C) 2010-2011  YannUbuntu (yannubuntu@gmail.com)         ##
##                                                                        ##
## This program is free software: you can redistribute it and/or modify   ##
## it under the terms of the GNU General Public License as published by   ##
## the Free Software Foundation, either version 3 of the License, or      ##
## (at your option) any later version.                                    ##
##                                                                        ##
## This program is distributed in the hope that it will be useful,        ##
## but WITHOUT ANY WARRANTY; without even the implied warranty of         ##
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          ##
## GNU General Public License for more details.                           ##
##                                                                        ##
## You should have received a copy of the GNU General Public License      ##
## along with this program.  If not, see <http://www.gnu.org/licenses/>.  ##
##                                                                        ##
############################################################################

g2slaunch() {
PACK_NAME=boot-sav
cd /usr/share/$PACK_NAME

# Ask root privileges
if [[ $EUID -ne 0 ]];then
	if hash gksu;then
		gksu $APPNAME  #TODO PolicyKit http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=492493
	elif hash su;then
		su -c $APPNAME
	else
		echo "Please install gksu or su"
	fi
	exit
fi

#avoid dpkg block when when upgrading from versions <=3.0
DISABLE_UPDATE_FROM_PPA=yes	# =yes for Debian packaging, =no for Boot-Repair-Disk packaging
if [[ ! -f packconfig.png ]] || [[ ! -x /usr/bin/glade2script ]] && [[ "$DISABLE_UPDATE_FROM_PPA" = "no" ]] && [[ "$(type apt-get)" ]];then
	zenity --info --timeout=10 --text="Please wait..." &
	apt-get -fy --force-yes install
	PACK=""
	hash boot-repair && PACK="$PACK boot-repair"
	hash os-uninstaller && PACK="$PACK os-uninstaller"
	hash ubiquity && PACK="$PACK clean-ubiquity"
	PACKNEW="boot-sav"
	PACKOLD="boot-sav-gui clean-ubiquity-common boot-repair-common clean clean-gui"
	for vvv in lucid oneiric finisterra;do	#to avoid python dep error
		zenity --info --timeout=5 --text="Updating, please wait..." &
		cp /etc/apt/sources.list /var/log/${PACK_NAME}/clean_sources
		for ppa in $PACK;do
			PPADEB="deb http://ppa.launchpad.net/yannubuntu/${ppa}/ubuntu ${vvv} main"
			if [[ ! "$(cat /etc/apt/sources.list )" =~ "${PPADEB}" ]] || [[ "$(cat /etc/apt/sources.list )" =~ "#${PPADEB}" ]] \
			|| [[ "$(cat /etc/apt/sources.list )" =~ "# ${PPADEB}" ]];then
				echo "${PPADEB}" >> /etc/apt/sources.list
			fi
		done
		apt-get -y update
		for removdeb in $PACK $PACKNEW $PACKOLD;do
			apt-get purge -y --force-yes $removdeb
		done
		apt-get install -y --force-yes $PACK
		rm /etc/apt/sources.list
		cp /var/log/${PACK_NAME}/clean_sources /etc/apt/sources.list
	done
fi

# Launch the Glade window via glade2script
if hash glade2script;then
	glade2script -g ./$PACK_NAME.glade -s ./$APPNAME.sh # -d for debug
else
	./glade2script.py -g ./$PACK_NAME.glade -s ./$APPNAME.sh
fi

# Reboot after update
if [[ "$DISABLE_UPDATE_FROM_PPA" = "no" ]] && [[ -f /var/log/${PACK_NAME}/reboot ]];then
	$APPNAME
fi

exit
}

