#! /bin/bash
############################################################################
##                                                                        ##
##     Copyright (C) 2010-2011  YannUbuntu (yannubuntu@gmail.com)         ##
##                                                                        ##
## This program is free software: you can redistribute it and/or modify   ##
## it under the terms of the GNU General Public License as published by   ##
## the Free Software Foundation, either version 3 of the License, or      ##
## (at your option) any later version.                                    ##
##                                                                        ##
## This program is distributed in the hope that it will be useful,        ##
## but WITHOUT ANY WARRANTY; without even the implied warranty of         ##
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          ##
## GNU General Public License for more details.                           ##
##                                                                        ##
## You should have received a copy of the GNU General Public License      ##
## along with this program.  If not, see <http://www.gnu.org/licenses/>.  ##
##                                                                        ##
############################################################################
## Special thanks to Babdu89 and GRUB devs.
## LIBRAIRIES FOR OS-UNINSTALLER AND BOOT REPAIR
## http://ubuntuforums.org/showthread.php?t=1615667

############### Backup table and logs
_button_backup_table() {
echo 'SET@_mainwindow.hide()'
echo 'SET@_backupwindow.show()'
}

_button_cancelbackup() {
echo 'SET@_mainwindow.show()'
echo 'SET@_backupwindow.hide()'
}

_backup_filechooserwidget() {
CHOSENBACKUPREP=${@}
echo "[debug]CHOSENBACKUPREP $CHOSENBACKUPREP"
}

_button_savebackup() {
echo 'SET@_backupwindow.hide()'
beginning_of_pulsate
echo "SET@_label0.set_text('''$Backup_table. $Please_wait''')"
echo "[debug]_button_savebackup"
for ((i=1;i<=TOTAL_QUANTITY_OF_OS;i++)); do
	cp -rn ${LOG_PATH[$i]}* ${LOG_PATH_LINUX}
done
FUNCTION="ZIP"
PACKAGELIST="zip"
FILETOTEST="zip"
installpackagelist
if [[ "$(type -p zip)" ]];then
	cd /var/log/$PACK_NAME
	temp="backup_$DATE$SECOND"
	temp2="${CHOSENBACKUPREP}/$temp"
	zip -r $temp2 *
	FILE="${temp2}.zip"
	update_translations
	end_of_pulsate
	zenity --info --text="$logs_have_been_saved_into_FILE"
	echo 'SET@_mainwindow.show()'
else
	end_of_pulsate
	echo 'SET@_backupwindow.hide()'
fi
}

############### Unhide bootmenu
_spinbutton_unhide_boot_menu() {
UNHIDEBOOT_TIME="${@}"; UNHIDEBOOT_TIME="${UNHIDEBOOT_TIME%*.0}"; echo "[debug]UNHIDEBOOT_TIME becomes : $UNHIDEBOOT_TIME"
}

_checkbutton_unhide_boot_menu() {
RETOURUNHID=${@}
if [[ ${RETOURUNHID} = True ]]; then
	UNHIDEBOOT_ACTION="yes"; echo 'SET@_spinbutton_unhide_boot_menu.set_sensitive(True)'
else
	UNHIDEBOOT_ACTION="no"; echo 'SET@_spinbutton_unhide_boot_menu.set_sensitive(False)'
fi
echo "[debug]UNHIDEBOOT_ACTION becomes : $UNHIDEBOOT_ACTION"
}


############## Reinstall GRUB
_checkbutton_reinstall_grub() {
RETOURREINST=${@}
if [[ ${RETOURREINST} = True ]]; then
	set_checkbutton_reinstall_grub
else
	show_tab_grub_location off
	show_tab_grub_options off
	[[ "$MBR_ACTION" != "restore" ]] &&	MBR_ACTION="nombraction"
	echo "[debug]MBR_ACTION becomes: $MBR_ACTION"
fi
}

set_checkbutton_reinstall_grub() {
echo "[debug]set_checkbutton_reinstall_grub"
show_tab_grub_location on
show_tab_grub_options on
show_tab_mbr_options off
echo 'SET@_checkbutton_restore_mbr.set_active(False)'
if [[ "$REINSTALL_POSSIBLE" = "yes" ]] && [[ "${GRUBVER[${LIST_OF_PART_FOR_REINSTAL[1]}]}" = grub2 ]];then
	echo 'SET@_combobox_purge_grub.set_sensitive(False)'
	echo 'SET@_combobox_ostoboot_bydefault.set_sensitive(True)'
	echo 'SET@_button_open_etc_default_grub.show()'
	echo 'SET@_checkbutton_lastgrub.set_sensitive(False)'
	MBR_ACTION="reinstall"; echo 'SET@_radiobutton_ostoboot_bydefault.set_active(True)'
	set_radiobutton_ostoboot_bydefault # necessary?
	separate_bootpart_show_hide $PART_TO_REINSTALL_GRUB
else
	echo 'SET@_combobox_ostoboot_bydefault.set_sensitive(False)'
	echo 'SET@_combobox_purge_grub.set_sensitive(True)'
	echo 'SET@_radiobutton_purge_grub.set_active(True)'
	echo 'SET@_button_open_etc_default_grub.hide()'
	echo 'SET@_checkbutton_lastgrub.set_sensitive(True)'
	MBR_ACTION="purge"
	separate_bootpart_show_hide $PART_TO_REINSTALL_GRUB_PURGE
fi
if [[ "$NBOFDISKS" != "1" ]];then
	FORCE_GRUB="all"; echo 'SET@_radiobutton_place_alldisks.set_active(True)'
else
	FORCE_GRUB="no"; echo 'SET@_radiobutton_place_grub.set_active(True)'
fi
echo "[debug]MBR_ACTION becomes : $MBR_ACTION"
}

################## Restore MBR
_checkbutton_restore_mbr() {
RETOURRESTORM=${@}
if [[ ${RETOURRESTORM} = True ]]; then
	set_checkbutton_restore_mbr
else
	show_tab_mbr_options off
	[[ "$MBR_ACTION" != "reinstall" ]] && [[ "$MBR_ACTION" != "purge" ]] &&	MBR_ACTION="nombraction"
	echo "[debug]MBR_ACTION becomes: $MBR_ACTION"
	echo 'SET@_checkbutton_bootflag.set_sensitive(True)'; set_bootflag
fi
}

set_checkbutton_restore_mbr() {
MBR_ACTION="restore"
echo 'SET@_checkbutton_reinstall_grub.set_active(False)'
show_tab_grub_location off
show_tab_grub_options off
show_tab_mbr_options on
if [[ "$MBR_TO_RESTORE" =~ generic ]] || [[ "$MBR_TO_RESTORE" =~ mbr ]];then
	echo 'SET@_vbox_partition_booted_bymbr.show()'
else
	echo 'SET@_vbox_partition_booted_bymbr.hide()'
fi
echo "[debug]MBR_ACTION becomes : $MBR_ACTION"
BOOTFLAG_ACTION="noflag"; echo 'SET@_checkbutton_bootflag.set_active(False)'; echo 'SET@_checkbutton_bootflag.set_sensitive(False)'
}

########################################## BOOTFLAG
fillin_bootflag_combobox() {
BOOTFLAG_NEEDED="noflag"
QTY_FLAGPART=0
if [[ "$MSDOSPRESENT" = "yes" ]];then
	for loop in 1 2 3;do
		for ((disk=1;disk<=NBOFDISKS;disk++)); do
			if [[ "${TABLE_TYPE[$disk]}" = "MSDos" ]];then
				ADDDISK=no
				if [[ ! "$(type -p parted)" ]];then
					ADDDISK=yes
				else
					p="$(LANGUAGE=C LC_ALL=C parted -l /dev/${LISTOFDISKS[$disk]} )"
					if [[ "$loop" = "1" ]] && [[ ! "$p" =~ boot ]];then
						ADDDISK=yes; BOOTFLAG_NEEDED="setflag" #Disk needing a bootflag
					elif [[ "$loop" = "2" ]] && [[ ! "$(echo $p | grep boot | grep primary)" ]] \
					&& [[ ! "$(echo $p | grep boot | grep extended)" ]] && [[ "$p" =~ boot ]];then
						ADDDISK=yes; BOOTFLAG_NEEDED="setflag"
					elif [[ "$(echo $p | grep boot | grep primary)" ]] || [[ "$(echo $p | grep boot | grep extended)" ]] \
					&& [[ "$loop" = "3" ]];then
						ADDDISK=yes
					fi
				fi
				if [[ "$ADDDISK" = "yes" ]];then
					TMPDISK="${LISTOFDISKS[$disk]}"
					order_primary_partitions_of_tmpdisk
					QTY_TARGETMBRPART="$QTY_PRIMPART"
					for ((i=1;i<=QTY_PRIMPART;i++)); do
						(( QTY_FLAGPART += 1 ))
						FLAGPART[$QTY_FLAGPART]="${PRIMPART[$i]}"			#e.g. ${LISTOFPARTITIONS[FLAGPART[a]]}= sda3
						FLAGPARTNAME[$QTY_FLAGPART]="${PRIMPARTNAME[$i]}"	#e.g. sda3 (XP)
					done
				fi
			fi
		done
	done
	if [[ "$QTY_GPTPART" != "0" ]];then
		BOOTFLAG_NEEDED="noflag"
	fi
fi
echo "COMBO@@CLEAR@@_combobox_bootflag"
if [[ "$QTY_FLAGPART" != "0" ]];then
	echo 'SET@_hbox_bootflag.show()'
	while read fichier; do echo "SET@_combobox_bootflag.append_text('''${fichier}''')";done < <( for ((i=1;i<=QTY_FLAGPART;i++)); do
		echo "${FLAGPARTNAME[$i]}"
	done)
	echo 'SET@_combobox_bootflag.set_active(0)'; BOOTFLAG_TO_USE="${FLAGPART[1]}"
	echo "[debug]BOOTFLAG_TO_USE is : ${LISTOFPARTITIONS[$BOOTFLAG_TO_USE]}"
	set_bootflag
fi
}

set_bootflag() {
BOOTFLAG_ACTION="noflag"
if [[ "$QTY_FLAGPART" != "0" ]] && [[ "$MBR_ACTION" != "restore" ]];then
	if [[ "$BOOTFLAG_NEEDED" = "setflag" ]];then
		BOOTFLAG_ACTION="setflag"
		echo 'SET@_checkbutton_bootflag.set_active(True)';  echo 'SET@_combobox_bootflag.set_sensitive(True)'
	else
		echo 'SET@_checkbutton_bootflag.set_active(False)'; echo 'SET@_combobox_bootflag.set_sensitive(False)'
	fi
fi
}

_checkbutton_bootflag() {
RETOURFLAG=${@}
if [[ ${RETOURFLAG} = True ]]; then
	echo 'SET@_button_mainapply.set_sensitive(False)' #To avoid applying before variables are changed
	FUNCTION="FLAG"
	PACKAGELIST="parted"
	FILETOTEST="parted"
	if [[ ! "$(type -p $FILETOTEST)" ]];then
		echo 'SET@_mainwindow.set_sensitive(False)'
		installpackagelist
		end_of_pulsate
		echo 'SET@_mainwindow.set_sensitive(True)' #dont show because window may not be initialized yet
	fi
	if [[ "$(type -p $FILETOTEST)" ]];then
		BOOTFLAG_ACTION="setflag"; echo 'SET@_combobox_bootflag.set_sensitive(True)'
	else
		BOOTFLAG_ACTION="noflag"; echo 'SET@_combobox_bootflag.set_sensitive(False)'
	fi
	echo 'SET@_button_mainapply.set_sensitive(True)'
else
	BOOTFLAG_ACTION="noflag"; echo 'SET@_combobox_bootflag.set_sensitive(False)'
fi
}

_combobox_bootflag() {
RETOURCOMBO_flag="${@}"
echo "[debug]RETOURCOMBO_flag (BOOTFLAG_TO_USE) : $RETOURCOMBO_flag"
for ((i=1;i<=QTY_FLAGPART;i++)); do
	[[ "$RETOURCOMBO_flag" = "${FLAGPARTNAME[$i]}" ]] && BOOTFLAG_TO_USE="${FLAGPART[$i]}"
done
echo "[debug]BOOTFLAG_TO_USE becomes : ${LISTOFPARTITIONS[$BOOTFLAG_TO_USE]}"
}
