#!/usr/bin/env python

import sys, os
from stat import *
from distutils.core import setup
from distutils.command.install import install as _install

INSTALLED_FILES = '.installed_files'

#stolen from ccsm
class install (_install):

	def run (self):

		_install.run(self)
		outputs = self.get_outputs()
		data = '\n'.join(outputs)
		try:
			f = open(INSTALLED_FILES, 'w')
		except:
			self.warn ('Could not write installed files list %s' %INSTALLED_FILES)
			return

		f.write(data)
		f.close()

class uninstall(_install):

	def run(self):
		try:
			files = file(INSTALLED_FILES, 'r').readlines()
		except:
			self.warn('Could not read installed files list %s' %INSTALLED_FILES)
			return

		for f in files:
			print 'Uninstalling %s' %f.strip()
			try:
				os.unlink(f.strip())
			except:
				self.warn('Could not remove file %s' %f)
		os.remove(INSTALLED_FILES)

data_files = [
	('share/boot-sav',['data/share/boot-sav/gui-scan.sh','data/share/boot-sav/packconfig.png','data/share/boot-sav/boot-sav.glade','data/share/boot-sav/gui-update.sh','data/share/boot-sav/gui-tab-loca.sh','data/share/boot-sav/gui-g2slaunch.sh','data/share/boot-sav/gui-init.sh','data/share/boot-sav/gui-tab-other.sh','data/share/boot-sav/gui-actions.sh','data/share/boot-sav/bs-common.sh','data/share/boot-sav/gui-tab-mbr.sh','data/share/boot-sav/bs-init.sh','data/share/boot-sav/gui-tab-grub.sh','data/share/boot-sav/gui-tab-main.sh','data/share/boot-sav/removegrub.png']),
	('share/locale/af/LC_MESSAGES',['data/share/locale/af/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ar/LC_MESSAGES',['data/share/locale/ar/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ast/LC_MESSAGES',['data/share/locale/ast/LC_MESSAGES/boot-sav.mo']),
	('share/locale/az/LC_MESSAGES',['data/share/locale/az/LC_MESSAGES/boot-sav.mo']),
	('share/locale/be/LC_MESSAGES',['data/share/locale/be/LC_MESSAGES/boot-sav.mo']),
	('share/locale/bg/LC_MESSAGES',['data/share/locale/bg/LC_MESSAGES/boot-sav.mo']),
	('share/locale/bn/LC_MESSAGES',['data/share/locale/bn/LC_MESSAGES/boot-sav.mo']),
	('share/locale/bs/LC_MESSAGES',['data/share/locale/bs/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ca/LC_MESSAGES',['data/share/locale/ca/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ckb/LC_MESSAGES',['data/share/locale/ckb/LC_MESSAGES/boot-sav.mo']),
	('share/locale/cs/LC_MESSAGES',['data/share/locale/cs/LC_MESSAGES/boot-sav.mo']),
	('share/locale/da/LC_MESSAGES',['data/share/locale/da/LC_MESSAGES/boot-sav.mo']),
	('share/locale/de/LC_MESSAGES',['data/share/locale/de/LC_MESSAGES/boot-sav.mo']),
	('share/locale/el/LC_MESSAGES',['data/share/locale/el/LC_MESSAGES/boot-sav.mo']),
	('share/locale/en_AU/LC_MESSAGES',['data/share/locale/en_AU/LC_MESSAGES/boot-sav.mo']),
	('share/locale/en_CA/LC_MESSAGES',['data/share/locale/en_CA/LC_MESSAGES/boot-sav.mo']),
	('share/locale/en_GB/LC_MESSAGES',['data/share/locale/en_GB/LC_MESSAGES/boot-sav.mo']),
	('share/locale/es/LC_MESSAGES',['data/share/locale/es/LC_MESSAGES/boot-sav.mo']),
	('share/locale/et/LC_MESSAGES',['data/share/locale/et/LC_MESSAGES/boot-sav.mo']),
	('share/locale/eu/LC_MESSAGES',['data/share/locale/eu/LC_MESSAGES/boot-sav.mo']),
	('share/locale/fa/LC_MESSAGES',['data/share/locale/fa/LC_MESSAGES/boot-sav.mo']),
	('share/locale/fi/LC_MESSAGES',['data/share/locale/fi/LC_MESSAGES/boot-sav.mo']),
	('share/locale/fil/LC_MESSAGES',['data/share/locale/fil/LC_MESSAGES/boot-sav.mo']),
	('share/locale/fr/LC_MESSAGES',['data/share/locale/fr/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ga/LC_MESSAGES',['data/share/locale/ga/LC_MESSAGES/boot-sav.mo']),
	('share/locale/gl/LC_MESSAGES',['data/share/locale/gl/LC_MESSAGES/boot-sav.mo']),
	('share/locale/gu/LC_MESSAGES',['data/share/locale/gu/LC_MESSAGES/boot-sav.mo']),
	('share/locale/he/LC_MESSAGES',['data/share/locale/he/LC_MESSAGES/boot-sav.mo']),
	('share/locale/hi/LC_MESSAGES',['data/share/locale/hi/LC_MESSAGES/boot-sav.mo']),
	('share/locale/hr/LC_MESSAGES',['data/share/locale/hr/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ht/LC_MESSAGES',['data/share/locale/ht/LC_MESSAGES/boot-sav.mo']),
	('share/locale/hu/LC_MESSAGES',['data/share/locale/hu/LC_MESSAGES/boot-sav.mo']),
	('share/locale/hy/LC_MESSAGES',['data/share/locale/hy/LC_MESSAGES/boot-sav.mo']),
	('share/locale/id/LC_MESSAGES',['data/share/locale/id/LC_MESSAGES/boot-sav.mo']),
	('share/locale/is/LC_MESSAGES',['data/share/locale/is/LC_MESSAGES/boot-sav.mo']),
	('share/locale/it/LC_MESSAGES',['data/share/locale/it/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ja/LC_MESSAGES',['data/share/locale/ja/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ka/LC_MESSAGES',['data/share/locale/ka/LC_MESSAGES/boot-sav.mo']),
	('share/locale/kn/LC_MESSAGES',['data/share/locale/kn/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ko/LC_MESSAGES',['data/share/locale/ko/LC_MESSAGES/boot-sav.mo']),
	('share/locale/lt/LC_MESSAGES',['data/share/locale/lt/LC_MESSAGES/boot-sav.mo']),
	('share/locale/lv/LC_MESSAGES',['data/share/locale/lv/LC_MESSAGES/boot-sav.mo']),
	('share/locale/mg/LC_MESSAGES',['data/share/locale/mg/LC_MESSAGES/boot-sav.mo']),
	('share/locale/mk/LC_MESSAGES',['data/share/locale/mk/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ms/LC_MESSAGES',['data/share/locale/ms/LC_MESSAGES/boot-sav.mo']),
	('share/locale/mt/LC_MESSAGES',['data/share/locale/mt/LC_MESSAGES/boot-sav.mo']),
	('share/locale/nb/LC_MESSAGES',['data/share/locale/nb/LC_MESSAGES/boot-sav.mo']),
	('share/locale/nl/LC_MESSAGES',['data/share/locale/nl/LC_MESSAGES/boot-sav.mo']),
	('share/locale/nn/LC_MESSAGES',['data/share/locale/nn/LC_MESSAGES/boot-sav.mo']),
	('share/locale/pl/LC_MESSAGES',['data/share/locale/pl/LC_MESSAGES/boot-sav.mo']),
	('share/locale/pt_BR/LC_MESSAGES',['data/share/locale/pt_BR/LC_MESSAGES/boot-sav.mo']),
	('share/locale/pt/LC_MESSAGES',['data/share/locale/pt/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ro/LC_MESSAGES',['data/share/locale/ro/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ru/LC_MESSAGES',['data/share/locale/ru/LC_MESSAGES/boot-sav.mo']),
	('share/locale/sk/LC_MESSAGES',['data/share/locale/sk/LC_MESSAGES/boot-sav.mo']),
	('share/locale/sl/LC_MESSAGES',['data/share/locale/sl/LC_MESSAGES/boot-sav.mo']),
	('share/locale/sq/LC_MESSAGES',['data/share/locale/sq/LC_MESSAGES/boot-sav.mo']),
	('share/locale/sr/LC_MESSAGES',['data/share/locale/sr/LC_MESSAGES/boot-sav.mo']),
	('share/locale/sv/LC_MESSAGES',['data/share/locale/sv/LC_MESSAGES/boot-sav.mo']),
	('share/locale/sw/LC_MESSAGES',['data/share/locale/sw/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ta/LC_MESSAGES',['data/share/locale/ta/LC_MESSAGES/boot-sav.mo']),
	('share/locale/te/LC_MESSAGES',['data/share/locale/te/LC_MESSAGES/boot-sav.mo']),
	('share/locale/th/LC_MESSAGES',['data/share/locale/th/LC_MESSAGES/boot-sav.mo']),
	('share/locale/tl/LC_MESSAGES',['data/share/locale/tl/LC_MESSAGES/boot-sav.mo']),
	('share/locale/tr/LC_MESSAGES',['data/share/locale/tr/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ug/LC_MESSAGES',['data/share/locale/ug/LC_MESSAGES/boot-sav.mo']),
	('share/locale/uk/LC_MESSAGES',['data/share/locale/uk/LC_MESSAGES/boot-sav.mo']),
	('share/locale/ur/LC_MESSAGES',['data/share/locale/ur/LC_MESSAGES/boot-sav.mo']),
	('share/locale/uz/LC_MESSAGES',['data/share/locale/uz/LC_MESSAGES/boot-sav.mo']),
	('share/locale/vi/LC_MESSAGES',['data/share/locale/vi/LC_MESSAGES/boot-sav.mo']),
	('share/locale/yi/LC_MESSAGES',['data/share/locale/yi/LC_MESSAGES/boot-sav.mo']),
	('share/locale/zh_CN/LC_MESSAGES',['data/share/locale/zh_CN/LC_MESSAGES/boot-sav.mo']),
	('share/locale/zh_HK/LC_MESSAGES',['data/share/locale/zh_HK/LC_MESSAGES/boot-sav.mo']),
	('share/locale/zh_TW/LC_MESSAGES',['data/share/locale/zh_TW/LC_MESSAGES/boot-sav.mo']),
]

setup(
	name='boot-sav',
	version='3.16',
	description="mini description",
	author='',
	author_email='',
	url='',
	data_files=data_files,
	scripts=[],
	cmdclass={
		'uninstall': uninstall,
		'install': install},
)

#Stolen from ccsm's setup.py
if sys.argv[1] == 'install':

	prefix = None

	if len (sys.argv) > 2:
		i = 0
		for o in sys.argv:
			if o.startswith ("--prefix"):
				if o == "--prefix":
					if len (sys.argv) >= i:
						prefix = sys.argv[i + 1]
					sys.argv.remove (prefix)
				elif o.startswith ("--prefix=") and len (o[9:]):
					prefix = o[9:]
				sys.argv.remove (o)
				break
			i += 1
